Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialCountEntry/FrmMaterialCountEntry.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialCountEntry/FrmMaterialCountEntry.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Material/MaterialCountEntry/FrmMaterialCountEntry.cs	(revision 51)
@@ -0,0 +1,707 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Text.RegularExpressions;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.Master;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+//*------------------------ 単位マスタメンテ画面 ----------------------*
+//  2015/07/14  Ver1.0.0.0      Create Source           
+//
+//
+//
+//*----------------------------------------------------------------------------*
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmMaterialCountEntry : Form
+    {
+        #region 使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 表示カラム
+        /// </summary>
+        private enum DispColumn
+        {
+            DisplayOrder = 0,
+            UnitKey,
+            NameString,
+        }
+
+        /// <summary>
+        /// マスタリストMAXライン
+        /// </summary>
+        private const int s_ListMaxLineCount = 53;
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// 資材種類
+        /// </summary>
+        public String m_MaterialType = "";
+
+        /// <summary>
+        /// 資材品目コード
+        /// </summary>
+        public int m_MaterialItemCode = 0;
+
+        /// <summary>
+        /// 資材品目
+        /// </summary>
+        public String m_MaterialItem = "";
+
+        /// <summary>
+        /// 資材数（変更前）
+        /// </summary>
+        public String m_MaterialCount = "";
+
+        /// <summary>
+        /// 割当可能数（変更前）
+        /// </summary>
+        public String m_MaterialAssignableCount = "";
+        /// <summary>
+
+        /// <summary>
+        /// データ操作
+        /// </summary>
+        private IOMaterialInfo m_IoM = null;
+
+        /// <summary>
+        /// 参照フラグ
+        /// </summary>
+        private bool m_EditLock = false;
+        #endregion
+
+        #region コンストラクタ
+        public FrmMaterialCountEntry()
+        {
+            InitializeComponent();
+        }
+        #endregion
+        #region デストラクタ
+        ~FrmMaterialCountEntry()
+        {
+            try
+            {
+                GC.Collect();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+
+        #region プロパティ
+
+        /// <summary>
+        /// 資材種類
+        /// </summary>
+        public string MaterialType
+        {
+            get { return m_MaterialType; }
+            set { m_MaterialType = value; }
+        }
+
+        /// <summary>
+        /// 資材品目コード
+        /// </summary>
+        public int MaterialItemCode
+        {
+            get { return m_MaterialItemCode; }
+            set { m_MaterialItemCode = value; }
+        }
+        /// <summary>
+        /// 資材品目
+        /// </summary>
+        public string MaterialItem
+        {
+            get { return m_MaterialItem; }
+            set { m_MaterialItem = value; }
+        }
+        
+        /// <summary>
+        /// 資材数（変更前）
+        /// </summary>
+        public string MaterialCount
+        {
+            get { return m_MaterialCount; }
+            set { m_MaterialCount = value; }
+        }
+        /// <summary>
+        /// 割当可能数（変更前）
+        /// </summary>
+        public string MaterialAssignableCount
+        {
+            get { return m_MaterialAssignableCount; }
+            set { m_MaterialAssignableCount = value; }
+        }
+
+        /// 参照フラグ
+        /// </summary>
+        public bool EditLock
+        {
+            get { return m_EditLock; }
+            set { m_EditLock = value; }
+        }
+        #endregion
+
+
+
+
+        #region イベントメソッド
+
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmMaterialCountEntry_Load(object sender, EventArgs e)
+        {
+            // 初期表示
+            InitDataLoad();
+
+            if (m_EditLock) txtDataEntry.Enabled = false;
+
+            // フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+        }
+
+        /// <summary>
+        /// ×ボタン押下処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        /// 
+        private void FrmMaterialCountEntry_FormClosing(object sender, FormClosingEventArgs e)
+        {
+            try
+            {
+                // 前プロセスに戻る
+                ClsExcute.BackProcess();
+
+            }
+            finally
+            {
+                // ロック解除用
+                if (e.Cancel != true && m_IoM != null)
+                {
+                    m_IoM.rollback();
+                    m_IoM.close();
+                    m_IoM = null;
+                }
+            }
+        }
+
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            this.Close();
+        }
+        /// <summary>
+        /// IMEのコントロール
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvMaster_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = (DataGridView)sender;
+
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //列によってIMEのモードを変更する
+                if (dgv.Columns[e.ColumnIndex].Name.Equals("Column3"))
+                {
+                    dgv.ImeMode = ImeMode.On;
+                }
+                else
+                {
+                    dgv.ImeMode = ImeMode.Disable;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        #endregion
+
+        #region プライベートメソッド
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            // ロック実行
+            try
+            {
+                m_IoM = new IOMaterialInfo();
+                m_IoM.connect();
+                m_IoM.SetLockWaitime(1);
+                m_IoM.beginTran();
+                // 共有ロック
+                if (!m_IoM.RowLockShare(m_MaterialItemCode, false))
+                {
+                    this.Close();
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                this.Close();
+            }
+
+            try
+            {
+                
+                // 資材種類
+                lblMaterialKind.Text = m_MaterialType;
+                
+                // 資材品目
+                lblMaterialItem.Text = m_MaterialItem;
+                
+                // 資材数
+                lblMaterialCount.Text = m_MaterialCount;
+                
+                // 割当可能数
+                lblRentCount.Text = m_MaterialAssignableCount;
+
+                // 資材数(変更後)
+                lblMaterialCountAfter.Text = "";
+
+                // 割当可能数(変更後)
+                lblRentCountAfter.Text = "";
+
+                // 追加
+                txtTuika.Text = "0";
+
+                // 破棄
+                txtHaki.Text = "0";
+
+                // コメント
+                txtComment.Text = ""; 
+
+                // 登録日にシステム日付を表示
+                lblMaterialDate.Text = DateTime.Now.ToString("yyyy/MM/dd");
+
+                // 担当にログインユーザー名を表示
+                lblPerson.Text = CommonMotions.LoginUserData.PersonName;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            string sError = "";
+            List<MaterialInfo> mi = new List<MaterialInfo>();
+
+            try
+            {
+                // 画面．「追加」、画面．「破棄」ともに0の場合はエラー ※未入力は0として扱う。
+                if ((CommonMotions.chkObjectIsNull(txtTuika.Text) || CommonMotions.cnvInt(txtTuika.Text) == 0)
+                   && (CommonMotions.chkObjectIsNull(txtHaki.Text) || CommonMotions.cnvInt(txtHaki.Text) == 0))
+                {
+                    sError = "追加、破棄ともに値が入力されていません。";
+                    bRet = false;
+                }
+
+
+                // レングスチェック
+                if (txtComment.Text.Length != 0)
+                {
+                    int len = Encoding.GetEncoding("Shift_JIS").GetByteCount(txtComment.Text);
+                    if (len > 80)
+                    {
+                        bRet = false;
+                        sError = "コメントは全角４０文字までで入力してください。";
+                    }
+                }
+  
+                //割り当て可能チェック
+                if (int.Parse(lblRentCount.Text) < int.Parse(txtHaki.Text))
+                {
+                    sError = "割当可能数を超えて破棄できません。";
+                    bRet = false; 
+                }
+
+                if (!bRet)
+                {
+                    MessageBox.Show(sError, "データ確認"
+                                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                }
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+
+        /// <summary>
+        /// 追加欄編集後の処理
+        /// </summary>
+        /// <returns></returns>
+        private void txtTuika_TextChanged(object sender, EventArgs e)
+        {
+            Regex regex = new Regex(@"^[0-9]+$");
+            Match match = regex.Match(txtTuika.Text);
+            if(match.Success)
+            {
+                // 総数　　　　→　変更前「資材数」＋画面.「追加」- 画面．「破棄」
+                lblMaterialCountAfter.Text = CommonMotions.cnvString(
+                CommonMotions.cnvInt(lblMaterialCount.Text) + CommonMotions.cnvInt(txtTuika.Text) - CommonMotions.cnvInt(txtHaki.Text));
+                // 割当可能数　→　変更前．「貸出可能数」＋画面．「追加」- 画面．「破棄」
+                lblRentCountAfter.Text = CommonMotions.cnvString(
+                CommonMotions.cnvInt(lblRentCount.Text) + CommonMotions.cnvInt(txtTuika.Text) - CommonMotions.cnvInt(txtHaki.Text));
+            }
+
+        }
+
+        /// <summary>
+        /// 破棄欄編集後の処理
+        /// </summary>
+        /// <returns></returns>
+        private void txtHaki_TextChanged(object sender, EventArgs e)
+        {
+            Regex regex = new Regex(@"^[0-9]+$");
+            Match match = regex.Match(txtHaki.Text);
+            if (match.Success)
+            {
+                // 入力された資材数を元に変更後に表示
+                // 総数　　　　→　変更前「資材数」＋画面.「追加」- 画面．「破棄」
+                lblMaterialCountAfter.Text = CommonMotions.cnvString(
+                    CommonMotions.cnvInt(lblMaterialCount.Text) + CommonMotions.cnvInt(txtTuika.Text) - CommonMotions.cnvInt(txtHaki.Text));
+                // 割当可能数　→　変更前．「貸出可能数」＋画面．「追加」- 画面．「破棄」
+                lblRentCountAfter.Text = CommonMotions.cnvString(
+                    CommonMotions.cnvInt(lblRentCount.Text) + CommonMotions.cnvInt(txtTuika.Text) - CommonMotions.cnvInt(txtHaki.Text));
+            }
+ 
+        }
+
+
+        #endregion
+
+
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDataEntry_Click(object sender, EventArgs e)
+        {
+
+            try
+            {
+                //データチェック
+                if (!DispFeildCheck()) return;
+
+                if (MessageBox.Show("表示中のデータを登録します。", "登録確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
+
+                // データ登録
+                if (!DataEntry()) 
+                {
+                    m_IoM.rollback();
+                    m_IoM.RowLockShare(m_MaterialItemCode, false);
+                    return;
+                }
+
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+            }
+
+        }
+
+        /// <summary>
+        /// データ登録
+        /// </summary>
+        private bool DataEntry()
+        {
+            MaterialInfo miwork = new MaterialInfo();
+
+            string strSQL = m_IoM.CreatePrimarykeyString(m_MaterialItemCode);
+            List<MaterialInfo> mList = new List<MaterialInfo>();
+
+            IOMaterialRecordInfo IoMri = new IOMaterialRecordInfo();
+
+            try
+            {
+                // 資材情報
+                miwork.MaterialItemCode = CommonMotions.cnvInt(m_MaterialItemCode);
+                miwork.MaterialCount = CommonMotions.cnvInt(lblMaterialCountAfter.Text);
+                miwork.RentCount = CommonMotions.cnvInt(lblRentCountAfter.Text);
+                miwork.DeleteFlg  = 0;
+
+
+                // 資材情報マスタ取得
+                if (!m_IoM.SelectAction(strSQL, ref mList, false))
+                {
+                    MessageBox.Show("登録確認に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+                if (mList.Count == 0)
+                {
+
+                    // 貸出可能数＜破棄数の場合はエラー
+                    if (CommonMotions.cnvInt(m_MaterialAssignableCount) < CommonMotions.cnvInt(txtHaki.Text))
+                    {
+                        MessageBox.Show("割当可能数を超えて破棄できません。", "登録エラー"
+                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                        return false;
+                    }
+
+                    // データがない場合は追加
+                    mList.Clear();
+                    mList.Add(miwork);
+
+                    // データ登録
+                    if (!m_IoM.InsertAction(mList, false))
+                    {
+                        MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+                else
+                {
+                    // 資材情報更新ロック
+                    m_IoM.rollback();
+                    if (!m_IoM.RowLockUpdate(m_MaterialItemCode, false))
+                    {
+                        m_IoM.RowLockShare(m_MaterialItemCode, false);
+                        MessageBox.Show("他のユーザで編集中のため、処理できません。", "登録エラー"
+                        , MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+
+                    // 貸出可能数＜破棄数の場合はエラー
+                    if (CommonMotions.cnvInt(mList[0].RentCount) < CommonMotions.cnvInt(txtHaki.Text))
+                    {
+                        m_IoM.rollback();
+                        m_IoM.RowLockShare(m_MaterialItemCode, false);
+                        MessageBox.Show("割当可能数を超えて破棄できません。", "登録エラー"
+                                , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                        return false;
+
+                    }
+
+                    // データ登録
+                    if (!m_IoM.UpdateAction(strSQL, miwork, false))
+                    {
+                        m_IoM.rollback();
+                        m_IoM.RowLockShare(m_MaterialItemCode, false);
+                        MessageBox.Show("更新に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+
+
+                // 資材履歴
+                IoMri.connect();
+                IoMri.beginTran();
+
+                if (CommonMotions.cnvInt(txtTuika.Text) > 0)            // 追加
+                {
+                    MaterialRecordInfo mriwork = new MaterialRecordInfo();
+
+                    mriwork.MaterialItemCode = CommonMotions.cnvInt(m_MaterialItemCode);
+                    mriwork.ProcessDate = CommonMotions.cnvDate(lblMaterialDate.Text);
+                    string strMrSql = IoMri.CreatePrimarykeyString(m_MaterialItemCode, mriwork.ProcessDate);
+                    mriwork.SeqNo = IoMri.SelectMaxMaterialRecordKeyCount(strMrSql) + 1;
+                    mriwork.RecKind = 2;
+                    mriwork.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                    mriwork.MaterialCount = CommonMotions.cnvInt(txtTuika.Text);
+                    mriwork.CommentText = CommonMotions.cnvString(txtComment.Text);
+
+                    List<MaterialRecordInfo> mRiList = new List<MaterialRecordInfo>();
+                    mRiList.Clear();
+                    mRiList.Add(mriwork);
+
+                    // データ登録
+                    if (!IoMri.InsertAction(mRiList))
+                    {
+                        m_IoM.rollback();
+                        m_IoM.RowLockShare(m_MaterialItemCode, false);
+                        IoMri.rollback();
+                        MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+
+                if (CommonMotions.cnvInt(txtHaki.Text) > 0)        // 破棄
+                {
+                    MaterialRecordInfo mriwork = new MaterialRecordInfo();
+
+                    mriwork.MaterialItemCode = CommonMotions.cnvInt(m_MaterialItemCode);
+                    mriwork.ProcessDate = CommonMotions.cnvDate(lblMaterialDate.Text);
+                    string strMrSql = IoMri.CreatePrimarykeyString(m_MaterialItemCode, mriwork.ProcessDate);
+                    mriwork.SeqNo = IoMri.SelectMaxMaterialRecordKeyCount(strMrSql) + 1;
+                    mriwork.RecKind = 3;
+                    mriwork.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                    mriwork.MaterialCount = CommonMotions.cnvInt(txtHaki.Text);
+                    mriwork.CommentText = CommonMotions.cnvString(txtComment.Text);
+
+                    List<MaterialRecordInfo> mRiList = new List<MaterialRecordInfo>();
+                    mRiList.Clear();
+                    mRiList.Add(mriwork);
+
+                    // データ登録
+                    if (!IoMri.InsertAction(mRiList))
+                    {
+                        m_IoM.rollback();
+                        m_IoM.RowLockShare(m_MaterialItemCode, false);
+                        IoMri.rollback();
+                        MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+
+                IoMri.commit();
+                m_IoM.commit();
+
+            }
+            finally 
+            {
+                if (IoMri != null)
+                {
+                    IoMri.close();
+                    IoMri = null;
+                }
+            }
+
+            return true;
+        }
+
+        /// <summary>
+        /// 追加フォーカス移動
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void txtTuika_Leave(object sender, EventArgs e)
+        {
+            Regex regex = new Regex(@"^[0-9]+$");
+            Match match = regex.Match(txtTuika.Text);
+            if (!match.Success)
+            {
+                MessageBox.Show("０以上の整数を入力してください。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                txtTuika.Focus();
+                return;
+            }
+
+            if (txtTuika.Text.Length > 0 && int.Parse(txtTuika.Text) > 0)
+            {
+                if (int.Parse(lblRentCount.Text) < int.Parse(txtHaki.Text))
+                {
+                    MessageBox.Show("割当可能数を超えて破棄できません。", "データ確認"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+
+                }
+            }
+        }
+
+        /// <summary>
+        /// 破棄フォーカス移動
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void txtHaki_Leave(object sender, EventArgs e)
+        {
+            Regex regex = new Regex(@"^[0-9]+$");
+            Match match = regex.Match(txtHaki.Text);
+            if (!match.Success)
+            {
+                MessageBox.Show("０以上の整数を入力してください。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                txtHaki.Focus();
+                return;
+            }
+
+            if (txtHaki.Text.Length > 0 && int.Parse(txtHaki.Text) > 0)
+            {
+                if (int.Parse(lblRentCount.Text) < int.Parse(txtHaki.Text))
+                {
+                    MessageBox.Show("割当可能数を超えて破棄できません。", "データ確認"
+                            , MessageBoxButtons.OK, MessageBoxIcon.Warning);
+
+                }
+            }
+        }
+
+        /// <summary>
+        /// 資材履歴ボタン押下時の処理
+        /// </summary>
+        private void btnMaterialHistory_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                
+                FrmMaterialHistory frm = new FrmMaterialHistory();
+
+                List<MaterialInfo> Mi = new List<MaterialInfo>();
+                m_IoM.SelectAction(string.Format(" where MaterialItemCode = {0}", MaterialItemCode), ref Mi, false);
+
+                //　遷移先への連携値
+                // パラメータセット
+                frm.MaterialType = CommonMotions.cnvString(MaterialType);
+                frm.MaterialItemCode = CommonMotions.cnvInt(MaterialItemCode);
+                frm.MaterialItem = CommonMotions.cnvString(MaterialItem);
+
+                if (Mi.Count != 0)
+                {
+                    frm.MaterialCount = CommonMotions.cnvString(Mi[0].MaterialCount);
+                    frm.MaterialAssignableCount = CommonMotions.cnvString(Mi[0].RentCount);
+                }
+                frm.ShowDialog();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+
+
+    }
+}
\ No newline at end of file
